diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeaturePillar.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeaturePillar.java
index fc3810948..947701048 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeaturePillar.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeaturePillar.java
@@ -13,7 +13,7 @@ public class WorldFeaturePillar
     private static int diameter(final int radius) {
         return radius * 2 + 1;
     }
-    private static final int CIRCLE_SCALE = 4;
+    private static final int CIRCLE_SCALE = 6;
 
     private final int blockId;
     private final boolean doLava;
@@ -25,17 +25,44 @@ public class WorldFeaturePillar
         this.doLava = doLava;
     }
 
+    private float[][] mult(float[][] ma, float[][] mb) {
+        float a = ma[0][0], b = ma[0][1], c = ma[0][2],
+                d = ma[1][0], e = ma[1][1], f = ma[1][2],
+                g = ma[2][0], h = ma[2][1], i = ma[2][2];
+        float j = mb[0][0], k = mb[0][1], l = mb[0][2],
+                m = mb[1][0], n = mb[1][1], o = mb[1][2],
+                p = mb[2][0], q = mb[2][1], r = mb[2][2];
+
+        return new float[][] {
+                {a * j + b * m + c * p, a * k + b * n + c * q, a * l + b * o + c * r},
+                {d * j + e * m + f * p, d * k + e * n + f * q, d * l + e * o + f * r},
+                {g * j + h * m + i * p, g * k + h * n + i * q, g * l + h * o + i * r}
+        };
+    }
+
+    private float[] mult(float[][] m, float[] v) {
+        return new float[] {
+                m[0][0] * v[0] + m[0][1] * v[1] + m[0][2] * v[2],
+                m[1][0] * v[0] + m[1][1] * v[1] + m[1][2] * v[2],
+                m[2][0] * v[0] + m[2][1] * v[1] + m[2][2] * v[2]
+        };
+    }
+
     @Override
     public boolean place(World world, Random random, int x, int y, int z) {
+        int x0 = random.nextInt(16) - 8 + x;
+        int z0 = random.nextInt(16) - 8 + z;
         int y0 = y;
 
-        while (isEmpty(world, x, y0, z)) {
+        while (isEmpty(world, x0, y0, z0)) {
             y0--;
         }
 
+        int x1 = random.nextInt(2) - 2 + x;
+        int z1 = random.nextInt(2) - 2 + z;
         int y1 = y;
 
-        while (isEmpty(world, x, y1, z)) {
+        while (isEmpty(world, x1, y1, z1)) {
             y1++;
         }
 
@@ -44,11 +71,42 @@ public class WorldFeaturePillar
 
         int length = y1 - y0;
 
+        if(length >= 128 || length <= 5)
+            return false;
+
+        int xd = (x1 - x0);
+        int yd = (y1 - y0);
+        int zd = (z1 - z0);
+
+        float dist = (float) Math.sqrt((xd * xd) + (yd * yd) + (zd * zd));
+
+        float xn = xd / dist;
+        float zn = zd / dist;
+
+        float[][] sxMatrix = {
+                {1, xn, 0},
+                {0, 1, 0},
+                {0, 0, 1}
+        };
+        float[][] szMatrix = {
+                {1, 0, 0},
+                {0, 1, 0},
+                {0, zn, 1}
+        };
+
+        float[][] matrix = mult(sxMatrix, szMatrix);
+
         float r = random.nextFloat();
-        int initRadiusTop = 1 + (int) (r * (MAX_RADIUS - 2));
+        int initRadiusTop = (int) (MAX_RADIUS - ((r * 4)+1));
         r = random.nextFloat();
-        int initRadiusBottom = initRadiusTop + (int) (r * (MAX_RADIUS - initRadiusTop));
-        int initRadiusMin = (int) (r * Math.min(initRadiusBottom, initRadiusTop) * 0.75f);
+        int initRadiusBottom = initRadiusTop;
+        int initRadiusMin = (int) (r * initRadiusBottom * 0.9f);
+
+
+        if(exposedBase(world, x1, y1+1, z1, initRadiusTop) || exposedBase(world, x0, y0-1, z0, initRadiusBottom)){
+            return false;
+        }
+
 
         int randomSkip = random.nextInt(8);
         if (randomSkip == 0) {
@@ -72,7 +130,7 @@ public class WorldFeaturePillar
             }
 
             float lerpedRadius = MathHelper.lerp(initRadiusBottom, initRadiusTop, p);
-            float radMod = (MathHelper.cos((2f * p) * MathHelper.PI) / 2 + 0.5f) * 0.75f + 0.25f;
+            float radMod = (MathHelper.cos((2f * p) * MathHelper.PI) / 2 + 0.5f) * 0.75f + 0.5f;
             float currentRadius = ((int) (lerpedRadius * radMod * CIRCLE_SCALE)) / (float) CIRCLE_SCALE;
             if (currentRadius < initRadiusMin) {
                 currentRadius = initRadiusMin;
@@ -82,10 +140,16 @@ public class WorldFeaturePillar
                 bufferedRadius = currentRadius;
             }
 
-            for (int dx = 0; dx < diameter(MAX_RADIUS); dx++) {
-                for (int dz = 0; dz < diameter(MAX_RADIUS); dz++) {
-                    if (getBufferPoint(dx, dz)) {
-                        world.setBlockWithNotify(x - MAX_RADIUS + dx, y0 + dy, z - MAX_RADIUS + dz, blockId);
+            for (int dx = -MAX_RADIUS; dx < MAX_RADIUS; dx++) {
+                for (int dz = -MAX_RADIUS; dz < MAX_RADIUS; dz++) {
+                    if (getBufferPoint(dx+MAX_RADIUS, dz+MAX_RADIUS)) {
+                        float[] v = {dx, dy, dz};
+                        float[] t = mult(matrix, v);
+
+                        int xW = x0 + MathHelper.floor(t[0]);
+                        int yW = y0 + MathHelper.floor(t[1]);
+                        int zW = z0 + MathHelper.floor(t[2]);
+                        world.setBlockWithNotify(xW, yW, zW, blockId);
                     }
                 }
             }
@@ -110,6 +174,17 @@ public class WorldFeaturePillar
         return true;
     }
 
+    private boolean exposedBase(World world, int x, int y, int z, int radius) {
+        for(int xi = -radius; xi < radius; xi++){
+            for(int zi = -radius; zi < radius; zi++){
+                if(!Blocks.solid[world.getBlockId(x + xi, y, z + zi)]){
+                    return true;
+                }
+            }
+        }
+        return false;
+    }
+
     private boolean isEmpty(World world, int x, int y, int z) {
         if (y < 0 || y >= world.getHeightBlocks()) {
             return false;
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureRubyglassCrystal.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureRubyglassCrystal.java
new file mode 100644
index 000000000..59bb9911e
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureRubyglassCrystal.java
@@ -0,0 +1,194 @@
+package net.minecraft.core.world.generate.feature;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.generate.voxelizer.ConvexShapeVoxelizer;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.joml.Matrix4f;
+import org.joml.Vector3f;
+
+import java.util.Objects;
+import java.util.Random;
+
+public class WorldFeatureRubyglassCrystal implements WorldFeatureInterface {
+    private static final float BASE_PCTG = 0.5f;
+
+    private final boolean isCeiling;
+    private final int minHeight;
+    private final int heightMod;
+
+    public WorldFeatureRubyglassCrystal(final boolean isCeiling) {
+        this(isCeiling, 20, 10);
+    }
+
+    public WorldFeatureRubyglassCrystal(final boolean isCeiling, final int minHeight, final int heightMod) {
+        this.isCeiling = isCeiling;
+        this.minHeight = minHeight;
+        this.heightMod = heightMod;
+    }
+
+    @Override
+    public boolean place(final @NotNull World world, final @NotNull Random random, final @NotNull TilePosc tilePos) {
+        final @NotNull TilePos ti = new TilePos(
+            (tilePos.x() + random.nextInt(2)) - random.nextInt(2),
+            tilePos.y(),
+            (tilePos.z() + random.nextInt(2)) - random.nextInt(2)
+        );
+
+        int floorY = -1;
+
+        int checksForGround = 0;
+        boolean foundGround = false;
+        boolean canGenerate = false;
+        int groundDepth = 0;
+        while (true) {
+            if (this.isCeiling)
+                ti.y++;
+            else
+                ti.y--;
+
+            if (checksForGround > 64 || ti.y < 0 || ti.y >= world.getHeightBlocks()) {
+                break;
+            }
+
+            final @NotNull Block<?> block = world.getBlockType(ti);
+
+            if (!foundGround) {
+                if (block == Blocks.COBBLE_NETHERRACK) {
+                    floorY = ti.y;
+                    foundGround = true;
+                }
+            } else {
+                groundDepth++;
+                if (block != Blocks.COBBLE_NETHERRACK) {
+                    break;
+                } else if (groundDepth >= 6) {
+                    canGenerate = true;
+                    break;
+                }
+            }
+
+            checksForGround++;
+        }
+
+        final @NotNull Block<?> block = world.getBlockType(ti);
+        if (canGenerate && (block == Blocks.COBBLE_NETHERRACK || block == Blocks.SOULSAND)) {
+            if (this.isCeiling) {
+                floorY += 1;
+            } else {
+                floorY -= 1;
+            }
+
+            this.placeCrystal(world, random, new TilePos(ti.x, floorY, ti.z));
+
+            return true;
+        }
+
+        return false;
+    }
+
+    private float randomOffset(final int length, final @NotNull Random random) {
+        final int base = length / 16;
+        return random.nextFloat() * base;
+    }
+
+    private void placeCrystal(final @NotNull World world, final @NotNull Random random, final @NotNull TilePosc tilePos) {
+        final float r = random.nextFloat();
+        final int length = this.minHeight + MathHelper.floor(Math.pow(r, 4) * this.heightMod);
+        final int base = length / 4;
+        float rx = 0;
+        float ry = 0;
+
+        final @NotNull TilePos ti = new TilePos(tilePos);
+
+        ti.y = this.isCeiling ? ti.y + (base / 2) : ti.y - (base / 2);
+
+        if (!this.hasSpace(world, ti, base)) {
+            return;
+        }
+
+        final float minBase = -(base / 2.0f);
+        final float maxBase = base / 2.0f;
+
+        final float randX = this.randomOffset(length, random);
+        final float randZ = this.randomOffset(length, random);
+
+        final @NotNull Vector3f @NotNull [] pts = new Vector3f[] {
+            // Cuboid
+            new Vector3f(minBase - randX, 0.0f, minBase - randZ),
+            new Vector3f(maxBase + randX, 0.0f, minBase - randZ),
+            new Vector3f(minBase - randX, 0.0f, maxBase + randZ),
+            new Vector3f(maxBase + randX, 0.0f, maxBase + randZ),
+            new Vector3f(minBase - randX, length, minBase - randZ),
+            new Vector3f(maxBase + randX, length, minBase - randZ),
+            new Vector3f(minBase - randX, length, maxBase + randZ),
+            new Vector3f(maxBase + randX, length, maxBase + randZ),
+
+            // Pyramid top
+            new Vector3f(0.0f, length + (maxBase * 4 * (random.nextFloat() * 0.5f + 0.5f)), 0.0f)
+        };
+
+        if (this.isCeiling) {
+            rx = MathHelper.PI;
+        }
+        rx += (float) ((random.nextDouble() - 0.5) * (Math.PI / 2)) * 0.8f;
+        ry += (float) (random.nextDouble() * 2.0 * Math.PI);
+
+        final @NotNull Matrix4f matrix = Objects.requireNonNull(new Matrix4f().rotateY(ry).rotateX(rx));
+
+        final int @NotNull [] @NotNull [] faces = {
+            { 0, 1, 3 }, // bottom face
+            { 0, 1, 5 }, // lower front
+            { 1, 3, 7 }, // lower right
+            { 3, 2, 6 }, // lower back
+            { 2, 0, 4 }, // lower left
+            { 4, 5, 8 }, // pyramid front
+            { 5, 7, 8 }, // pyramid right
+            { 7, 6, 8 }, // pyramid back
+            { 6, 4, 8 }  // pyramid left
+        };
+
+        final @NotNull ConvexShapeVoxelizer voxelizer = new ConvexShapeVoxelizer(
+            pts,
+            faces,
+            matrix,
+            (worldPos, replacing, faceDistances) -> {
+                if (replacing == Blocks.BEDROCK) {
+                    return null;
+                }
+
+                final float distancePctg = faceDistances[0] / length;
+                if (distancePctg < BASE_PCTG) {
+                    final float innerDistancePctg = distancePctg / BASE_PCTG;
+                    if (innerDistancePctg < random.nextFloat()) {
+                        return Blocks.COBBLE_NETHERRACK_CRYSTALLINE;
+                    } else {
+                        return Blocks.RUBYGLASS;
+                    }
+                } else {
+                    return Blocks.RUBYGLASS;
+                }
+            }
+        );
+
+        voxelizer.voxelize(world, ti);
+    }
+
+    private boolean hasSpace(final @NotNull World world, final @NotNull TilePosc tilePos, final int base) {
+        final @NotNull TilePos ti = new TilePos();
+
+        for (ti.y = tilePos.y(); ti.y < tilePos.y() + base; ti.y++) {
+            for (ti.x = tilePos.x() - base; ti.x < tilePos.x() + base; ti.x++) {
+                for (ti.z = tilePos.z() - base; ti.z < tilePos.z() + base; ti.z++) {
+                    if (world.getBlockType(ti) == Blocks.RUBYGLASS)
+                        return false;
+                }
+            }
+        }
+        return true;
+    }
+}
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureRubyglassGrowthPatch.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureRubyglassGrowthPatch.java
new file mode 100644
index 000000000..03ea15cca
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureRubyglassGrowthPatch.java
@@ -0,0 +1,36 @@
+package net.minecraft.core.world.generate.feature;
+
+import net.minecraft.core.block.BlockLogicRubyglassGrowth;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
+
+import java.util.Random;
+
+public class WorldFeatureRubyglassGrowthPatch extends WorldFeature
+{
+    private final int blockId;
+
+    public WorldFeatureRubyglassGrowthPatch()
+    {
+        this.blockId = Blocks.RUBYGLASS_SPROUT.id();
+    }
+
+    @Override
+	public boolean place(World world, Random random, int x, int y, int z)
+    {
+        for(int i1 = 0; i1 < 20; i1++)
+        {
+            int x1 = (x + random.nextInt(4)) - random.nextInt(4);
+            int y1 = (y + random.nextInt(4)) - random.nextInt(4);
+            int z1 = (z + random.nextInt(4)) - random.nextInt(4);
+            if(world.isAirBlock(x1, y1, z1) && Blocks.blocksList[blockId].canBlockStay(world, x1, y1, z1))
+            {
+                world.setBlock(x1, y1, z1, blockId);
+                BlockLogicRubyglassGrowth.setDefaultDirection(world, new TilePos(x1, y1, z1));
+            }
+        }
+
+        return true;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureTerrace.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureTerrace.java
new file mode 100644
index 000000000..944ddf5ad
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureTerrace.java
@@ -0,0 +1,90 @@
+package net.minecraft.core.world.generate.feature;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
+import org.jetbrains.annotations.NotNull;
+
+import java.util.Random;
+
+public class WorldFeatureTerrace extends WorldFeature
+{
+    private final @NotNull Block<?> fillBlock;
+    private final @NotNull Block<?> wallBlock;
+    private final int minRadius;
+    private final int radiusMod;
+    public WorldFeatureTerrace(@NotNull Block<?> fillBlock, @NotNull Block<?> wallBlock)
+    {
+        this.fillBlock = fillBlock;
+        this.wallBlock = wallBlock;
+        this.minRadius = 6;
+        this.radiusMod = 6;
+    }
+
+    @Override
+	public boolean place(World world, Random random, int x, int y, int z)
+    {
+        int radius = minRadius + random.nextInt(radiusMod);
+
+        TilePos centerPos = new TilePos(x + random.nextInt(8), y, z + random.nextInt(8));
+        TilePos cursor = new TilePos();
+
+        TilePos queryPos = new TilePos();
+
+        for(cursor.x = centerPos.x() - radius; cursor.x <= centerPos.x() + radius; cursor.x++) {
+            for (cursor.z = centerPos.z() - radius; cursor.z <= centerPos.z() + radius; cursor.z++) {
+                int xd = cursor.x() - centerPos.x();
+                int zd = cursor.z() - centerPos.z();
+
+                float dist = xd * xd + zd * zd;
+
+                for(cursor.y = world.getWorldType().getMaxY(world); cursor.y > world.getWorldType().getOceanY() + 4; cursor.y--) {
+
+                    // Skip placement if cursor hasn't hit ground yet
+                    if(world.isAirBlock(cursor)) {
+                        continue;
+                    }
+
+                    if (dist <= (radius * radius) && canPlaceWall(cursor, queryPos, world)) {
+                        world.setBlockTypeNotify(cursor, wallBlock);
+                    }
+
+                    if (dist <= ((radius-1) * (radius-1)) && canPlacePool(cursor, queryPos, world)) {
+                        world.setBlockTypeNotify(cursor, fillBlock);
+                    }
+                }
+            }
+        }
+        return true;
+    }
+
+    private boolean canPlaceWall(TilePos cursor, TilePos query, World world) {
+        cursor.add(Direction.UP, query);
+        if (!world.isAirBlock(query)) {
+            return false;
+        }
+
+        return world.getBlockType(cursor).hasTag(BlockTags.NETHER_SURFACE_BLOCK);
+    }
+
+    private boolean canPlacePool(TilePos cursor, TilePos query, World world) {
+        if(!world.getBlockType(cursor).hasTag(BlockTags.NETHER_SURFACE_BLOCK)){
+            return false;
+        }
+
+        for (Direction dir : Direction.directions) {
+            cursor.add(dir, query);
+            if(dir == Direction.UP){
+                if (!world.isAirBlock(query)) {
+                    return false;
+                }
+            } else if(world.isAirBlock(query) || !(world.getBlockType(cursor).hasTag(BlockTags.NETHER_SURFACE_BLOCK))){
+                return false;
+            }
+        }
+        return true;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureThermalSpire.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureThermalSpire.java
new file mode 100644
index 000000000..ad7bb23dd
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureThermalSpire.java
@@ -0,0 +1,63 @@
+package net.minecraft.core.world.generate.feature;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
+import org.joml.Vector2i;
+import org.joml.Vector3i;
+import org.joml.Vector3ic;
+
+import java.util.Random;
+
+public class WorldFeatureThermalSpire extends WorldFeature{
+    @Override
+    public boolean place(World world, Random random, int x, int y, int z) {
+        TilePos pos = new TilePos(x, y, z);
+        while(world.isAirBlock(pos) && pos.y - 1 > 0) {pos.down(); }
+        if (hasSpace(world, pos.x, pos.y, pos.z)) {
+
+            Vector3i highestOffset = new Vector3i(0, 0, 0);
+            TilePos centerPos = new TilePos(pos.x, pos.y, pos.z);
+            TilePos queryPos = new TilePos();
+
+            for (int x1 = 0; x1 < 2; x1++) {
+                for (int z1 = 0; z1 < 2; z1++) {
+                    int height = random.nextInt(4) + 2;
+                    if(height > highestOffset.y) {
+                        highestOffset.set(x1, height, z1);
+                    }
+
+                    for(int y1 = 0; y1 < height; y1++){
+                        centerPos.add(x1, y1, z1, queryPos);
+                        world.setBlockType(queryPos, Blocks.BASALT);
+                    }
+                }
+            }
+
+            for(int y1 = 0; y1 < 2; y1++){
+                centerPos.add(highestOffset.x, highestOffset.y + y1, highestOffset.z, queryPos);
+                world.setBlockType(queryPos, Blocks.THERMAL_VENT);
+            }
+        }
+
+
+        return true;
+    }
+
+    private boolean hasSpace(World world, int xc, int y, int zc){
+        TilePos queryPos =  new TilePos();
+        for (queryPos.y = y - 3; queryPos.y < y + 3; queryPos.y++) {
+            for (queryPos.x = xc - 3; queryPos.x < xc + 3; queryPos.x++) {
+                for (queryPos.z = zc - 3; queryPos.z < zc + 3; queryPos.z++) {
+                    if (!world.isAirBlock(queryPos) && !world.getBlockType(queryPos).hasTag(BlockTags.NETHER_SURFACE_BLOCK))
+                        return false;
+                }
+            }
+        }
+        return true;
+    }
+
+
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureThermalVents.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureThermalVents.java
new file mode 100644
index 000000000..1597cd77b
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureThermalVents.java
@@ -0,0 +1,68 @@
+package net.minecraft.core.world.generate.feature;
+
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
+
+import java.util.Random;
+
+public class WorldFeatureThermalVents extends WorldFeature
+{
+
+    private final int minRadius;
+    private final int radiusMod;
+
+
+    public WorldFeatureThermalVents(int minRadius, int radiusMod)
+    {
+        this.minRadius = minRadius;
+        this.radiusMod = radiusMod;
+    }
+
+    public WorldFeatureThermalVents()
+    {
+        this.minRadius = 4;
+        this.radiusMod = 6;
+    }
+
+    @Override
+	public boolean place(World world, Random random, int x, int y, int z)
+    {
+        int radius = minRadius + random.nextInt(radiusMod);
+
+        TilePos tilePos = new TilePos(x, y, z);
+        while(world.isAirBlock(tilePos) && tilePos.y - 1 > 0) {tilePos.down(); }
+
+        TilePos queryPos = new TilePos();
+        TilePos blockAbove = new TilePos();
+
+        for (int r = 0; r < 10; r++) {
+            int radModX = random.nextInt(radius) - random.nextInt(radius);
+            int radModY = random.nextInt(radius) - random.nextInt(radius);
+            int radModZ = random.nextInt(radius) - random.nextInt(radius);
+
+            int height = random.nextInt(5);
+
+            tilePos.add(radModX, radModY, radModZ, queryPos);
+            queryPos.add(0, 1, 0, blockAbove);
+            boolean canBlockSpawn = world.getBlockType(queryPos).hasTag(BlockTags.NETHER_SURFACE_BLOCK);
+
+            if (canBlockSpawn) {
+                for(int i = 1; i < height; i++){
+                    queryPos.add(0, i, 0, blockAbove);
+
+                    if(!world.isAirBlock(blockAbove)){
+                        break;
+                    }
+
+                    world.setBlockTypeNotify(blockAbove, Blocks.THERMAL_VENT);
+                }
+            }
+
+        }
+
+        return true;
+    }
+}
